<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_HotelAdditionalElement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_HotelAdditionalElement extends AbstractStructArrayBase
{
    /**
     * The HotelSupplement
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_HotelAdditionalElement[]
     */
    public $HotelSupplement;
    /**
     * Constructor method for ArrayOfJP_HotelAdditionalElement
     * @uses ArrayOfJP_HotelAdditionalElement::setHotelSupplement()
     * @param \StructType\JP_HotelAdditionalElement[] $hotelSupplement
     */
    public function __construct(array $hotelSupplement = array())
    {
        $this
            ->setHotelSupplement($hotelSupplement);
    }
    /**
     * Get HotelSupplement value
     * @return \StructType\JP_HotelAdditionalElement[]|null
     */
    public function getHotelSupplement()
    {
        return $this->HotelSupplement;
    }
    /**
     * This method is responsible for validating the values passed to the setHotelSupplement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHotelSupplement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHotelSupplementForArrayConstraintsFromSetHotelSupplement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_HotelAdditionalElementHotelSupplementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_HotelAdditionalElementHotelSupplementItem instanceof \StructType\JP_HotelAdditionalElement) {
                $invalidValues[] = is_object($arrayOfJP_HotelAdditionalElementHotelSupplementItem) ? get_class($arrayOfJP_HotelAdditionalElementHotelSupplementItem) : sprintf('%s(%s)', gettype($arrayOfJP_HotelAdditionalElementHotelSupplementItem), var_export($arrayOfJP_HotelAdditionalElementHotelSupplementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HotelSupplement property can only contain items of type \StructType\JP_HotelAdditionalElement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HotelSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelAdditionalElement[] $hotelSupplement
     * @return \ArrayType\ArrayOfJP_HotelAdditionalElement
     */
    public function setHotelSupplement(array $hotelSupplement = array())
    {
        // validation for constraint: array
        if ('' !== ($hotelSupplementArrayErrorMessage = self::validateHotelSupplementForArrayConstraintsFromSetHotelSupplement($hotelSupplement))) {
            throw new \InvalidArgumentException($hotelSupplementArrayErrorMessage, __LINE__);
        }
        $this->HotelSupplement = $hotelSupplement;
        return $this;
    }
    /**
     * Add item to HotelSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelAdditionalElement $item
     * @return \ArrayType\ArrayOfJP_HotelAdditionalElement
     */
    public function addToHotelSupplement(\StructType\JP_HotelAdditionalElement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_HotelAdditionalElement) {
            throw new \InvalidArgumentException(sprintf('The HotelSupplement property can only contain items of type \StructType\JP_HotelAdditionalElement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HotelSupplement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelSupplement
     */
    public function getAttributeName()
    {
        return 'HotelSupplement';
    }
}
